> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rallyuxr.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create multiple new person properties



## OpenAPI

````yaml https://api.rallyuxr.com/api/openapi post /properties/import
openapi: 3.1.0
info:
  title: Rally UXR Developer Docs
  version: '1.0'
servers:
  - url: https://api.rallyuxr.com/api/public/v1
security:
  - bearerAuth: []
tags:
  - name: Forms
    description: Operations on Forms in your workspace
  - name: People
    description: Operations on Person's stored in your workspace
  - name: Person Properties
    description: Operations on workspace level Person Properties
  - name: Populations
    description: Operations on Populations in your workspace
  - name: Segments
    description: Operations on Segments in your workspace
  - name: Studies
    description: Operations on Studies in your workspace
  - name: Participants
    description: Operations on Participants in studies
  - name: Screener
    description: Operations on a study's screener
  - name: Consent Submissions
    description: Operations on Consent Submissions for studies
  - name: Incentives
    description: Operations on Incentives in your workspace
  - name: Messages
    description: Operations on Message activities in your workspace
  - name: Imports
    description: Operations on Imports in your workspace
  - name: Users
    description: Operations on Workspace Users
  - name: Teams
    description: Operations on Teams in your workspace
  - name: Backfills
    description: >-
      Routes that can be used to backfill data into Rally. If you'd like access
      to these apis, please reach out to your Customer Success rep
  - name: Person
    description: Deprecated, use People
paths:
  /properties/import:
    post:
      tags:
        - Person Properties
      summary: Create multiple new person properties
      requestBody:
        content:
          application/json:
            schema:
              type: array
              items:
                $ref: '#/components/schemas/AddPersonProperty'
              maxItems: 10
              description: Input object for adding multiple person properties
      responses:
        '200':
          description: The created person properties
          headers:
            X-RateLimit-Limit:
              $ref: '#/components/headers/X-RateLimit-Limit'
            X-RateLimit-Remaining:
              $ref: '#/components/headers/X-RateLimit-Remaining'
            X-RateLimit-Reset:
              $ref: '#/components/headers/X-RateLimit-Reset'
          content:
            application/json:
              schema:
                type: object
                properties:
                  results:
                    type: array
                    items:
                      type: object
                      properties:
                        personProperty:
                          $ref: '#/components/schemas/PersonProperty'
                        isAsync:
                          type: boolean
                          description: >-
                            If there is an async action as a result of updating
                            existing people in the workspace
                        bulkActionUserRequestId:
                          type: string
                          description: >-
                            The id of the bulk action user request if there is
                            an async action as a result of updating existing
                            people in the workspace
                      required:
                        - personProperty
                        - isAsync
                    description: The person properties that were created
                  errors:
                    type: array
                    items:
                      type: object
                      properties:
                        message:
                          type: string
                        path:
                          type: array
                          items:
                            anyOf:
                              - type: string
                              - type: number
                        name:
                          type: string
                          description: The name of the property that failed to create
                      required:
                        - message
                        - path
                        - name
                    description: The properties that failed to create
                required:
                  - results
                  - errors
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequestError'
        '401':
          description: Unauthorized
          headers:
            X-RateLimit-Limit:
              $ref: '#/components/headers/X-RateLimit-Limit'
            X-RateLimit-Remaining:
              $ref: '#/components/headers/X-RateLimit-Remaining'
            X-RateLimit-Reset:
              $ref: '#/components/headers/X-RateLimit-Reset'
          content:
            text/plain:
              schema:
                type: string
                example: Unauthorized
        '403':
          description: Forbidden
          headers:
            X-RateLimit-Limit:
              $ref: '#/components/headers/X-RateLimit-Limit'
            X-RateLimit-Remaining:
              $ref: '#/components/headers/X-RateLimit-Remaining'
            X-RateLimit-Reset:
              $ref: '#/components/headers/X-RateLimit-Reset'
          content:
            text/plain:
              schema:
                type: string
                example: Forbidden
        '404':
          description: Not Found
          content:
            text/plain:
              schema:
                type: string
                example: '{Resource} not found'
        '429':
          description: Too Many Requests
          headers:
            Retry-After:
              $ref: '#/components/headers/Retry-After'
            X-RateLimit-Limit:
              $ref: '#/components/headers/X-RateLimit-Limit'
            X-RateLimit-Remaining:
              $ref: '#/components/headers/X-RateLimit-Remaining'
            X-RateLimit-Reset:
              $ref: '#/components/headers/X-RateLimit-Reset'
          content:
            text/plain:
              schema:
                type: string
                example: Too Many Requests
        '500':
          description: Internal Server Error
          headers:
            X-RateLimit-Limit:
              $ref: '#/components/headers/X-RateLimit-Limit'
            X-RateLimit-Remaining:
              $ref: '#/components/headers/X-RateLimit-Remaining'
            X-RateLimit-Reset:
              $ref: '#/components/headers/X-RateLimit-Reset'
          content:
            text/plain:
              schema:
                type: string
                example: Internal Server Error
      security:
        - bearerAuth: []
components:
  schemas:
    AddPersonProperty:
      type: object
      properties:
        name:
          type: string
          description: The name of the property
          example: Company Size
        propertyType:
          $ref: '#/components/schemas/PropertyType'
        propertyOptions:
          type: array
          items:
            type: object
            properties:
              name:
                type: string
                description: The name of the option
              color:
                $ref: '#/components/schemas/PersonPropertyOptionColor'
              order:
                type: string
                description: >-
                  The order of the option. Sorted by this string value, ie: it
                  can be a number
                examples:
                  - '1'
                  - a
                  - A
                example: '1'
            required:
              - name
            description: >-
              Input object for adding a property option to a `SINGLE_SELECT` or
              `MULTI_SELECT` property
            example:
              name: SMB (1 - 100 employees)
              color: GREEN
          maxItems: 100
          description: >-
            Options for a `SINGLE_SELECT` or `MULTI_SELECT` property. Errors if
            passed for other property types
          example:
            - name: SMB (1 - 100 employees)
              color: GREEN
            - name: Mid Market (101 - 2000 employees)
              color: YELLOW
            - name: Enterprise (2000+ employees)
              color: BLUE
        isUnique:
          type: boolean
          description: >-
            Whether the property is unique across all people. Maximum of 10
            across a workspace
          maximum: 10
          example: false
        isPHI:
          type: boolean
          description: Whether the property is PHI (Protected health information)
          example: false
        isPII:
          type: boolean
          description: Whether the property is PII (Personally Identifiable Information)
          example: false
        description:
          type: string
          description: The description of the property
          example: A description of the property
      required:
        - name
        - propertyType
      description: Input object for adding a person property
    PersonProperty:
      type: object
      properties:
        propertyId:
          type: string
          description: The unique identifier of the property
        name:
          type: string
          description: The name of the property
        propertyType:
          $ref: '#/components/schemas/PropertyType'
        propertyOptions:
          type: array
          items:
            $ref: '#/components/schemas/PersonPropertyOption'
          description: >-
            Options for a `SINGLE_SELECT` or `MULTI_SELECT` property. Empty for
            other property types.
        isUnique:
          type: boolean
          description: >-
            Whether the property is unique across all people. Maximum of 10
            across a workspace
          maximum: 10
        isPHI:
          type: boolean
          description: Whether the property is PHI (Protected health information)
        isPII:
          type: boolean
          description: Whether the property is PII (Personally Identifiable Information)
        description:
          type:
            - string
            - 'null'
          description: The description of the property
        propertyGroupId:
          type:
            - string
            - 'null'
          description: >-
            The identifier of the property group this property belongs to. A
            property group is a collection of properties that apply to either
            all people in the workspace or a specific set of populations.
      required:
        - propertyId
        - name
        - propertyType
        - propertyOptions
        - isUnique
        - isPHI
        - isPII
        - description
        - propertyGroupId
      description: An individual person property
    BadRequestError:
      type: object
      properties:
        errors:
          type: array
          items:
            type: object
            properties:
              message:
                type: string
              path:
                type: array
                items:
                  anyOf:
                    - type: string
                    - type: number
            required:
              - message
              - path
      required:
        - errors
      description: Error response for a bad request with details on what was invalid
    PropertyType:
      type: string
      enum:
        - STRING
        - NUMBER
        - DATETIME
        - BOOLEAN
        - SINGLE_SELECT
        - MULTI_SELECT
        - LOCATION
      description: The type of the property
      example: SINGLE_SELECT
    PersonPropertyOptionColor:
      type: string
      enum:
        - GREY
        - YELLOW
        - BLUE
        - RED
        - GREEN
        - ORANGE
      description: The color of the option shown in the UI
    PersonPropertyOption:
      type: object
      properties:
        propertyOptionId:
          type: string
        name:
          type: string
          description: The name of the option
        color:
          $ref: '#/components/schemas/PersonPropertyOptionColor'
        order:
          type: string
          description: >-
            The order of the option. Sorted by this string value, ie: it can be
            a number
          examples:
            - '1'
            - a
            - A
          example: '1'
      required:
        - propertyOptionId
        - name
        - color
        - order
      description: An individual person property option
  headers:
    X-RateLimit-Limit:
      description: The maximum number of requests the client is allowed to make.
      schema:
        type: integer
        format: int32
    X-RateLimit-Remaining:
      description: >-
        The number of requests remaining for the client in the current time
        window.
      schema:
        type: integer
        format: int32
    X-RateLimit-Reset:
      description: >-
        The time at which the current time window ends (in Unix timestamp
        format).
      schema:
        type: integer
        format: int32
    Retry-After:
      description: The number of seconds until the client should retry the request.
      schema:
        type: integer
        format: int32
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````